#!/usr/bin/env python

"""Send the contents of a directory as a MIME message."""

import mysql.connector
import os
import sys
import smtplib
# For guessing MIME type based on file name extension
import mimetypes

from optparse import OptionParser

from email import encoders
from email.message import Message
from email.mime.audio import MIMEAudio
from email.mime.base import MIMEBase
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText

import default_setting

COMMASPACE = ', '

def main():
	parser = OptionParser(usage="""\
Send the contents of a directory as a MIME message.

Usage: %prog [options]

Unless the -o option is given, the email is sent by forwarding to your local
SMTP server, which then does the normal delivery process.  Your local machine
must be running an SMTP server.
""")
	parser.add_option('-d', '--directory',
			type='string', action='store',
			help="""Mail the contents of the specified directory,
			otherwise use the current directory.  Only the regular
			files in the directory are sent, and we don't recurse to
			subdirectories.""")
	parser.add_option('-o', '--output',
			type='string', action='store', metavar='FILE',
			help="""Print the composed message to FILE instead of
			sending the message to the SMTP server.""")
	parser.add_option('-s', '--sender',
			type='string', action='store', metavar='SENDER',
			help='The value of the From: header (required)')
	parser.add_option('-r', '--recipient',
			type='string', action='append', metavar='RECIPIENT',
			default=[], dest='recipients',
			help='A To: header value (at least one required)')
	parser.add_option('-j', '--jobname',
			type='string', action='store', metavar='JOBNAME',
			help="""Job_name, link to reports table, for email distribution list""")
			
	opts, args = parser.parse_args()
	if not opts.sender or (not opts.recipients and not opts.jobname):
		parser.print_help()
		sys.exit(1)
	directory = opts.directory
	if not directory:
		directory = '.'
		
	defaults = default_setting.defaultSettings()
	
#	if opts.recipients == "":
	recipients = getRecipients(defaults,opts.jobname)
#	else:
#		mailTo = opts.recipients
		
	createMail(directory, opts.sender, recipients, opts.output)

# Get email addresses
def getRecipients(defaults,jobname):
	cnx = mysql.connector.connect(user=defaults['dbuser'], password=defaults['dbpwd'],host=defaults['dbhost'],database=defaults['dbase'])
	
	print("jobname:"+jobname)
	
	try:
		dataQuery = "SELECT distribution_list FROM report WHERE job_name='"+jobname+"' LIMIT 1"
		cursor = cnx.cursor(dictionary=True)
		cursor.execute(dataQuery)
		data = cursor.fetchall()
		r = 1
		for row in data:
			print (row['distribution_list'])
			mailTo = (row['distribution_list'])
			r = r+1			
	except UnboundLocalError:
		raise 'MySql Error'
		
	finally:
		try:
			cursor.close()
			cnx.close()
		except:
			pass
	recipients = mailTo.split(",")
	return recipients		

def createMail(directory, sender, recipients, output,subject=''):
# Create the enclosing (outer) message
	outer = MIMEMultipart()
#	outer['Subject'] = 'Contents of directory %s' % os.path.abspath(directory)   
	outer['Subject'] = 'VIMS - Report '+subject
	outer['To'] = COMMASPACE.join(recipients)
#	outer['To'] = mailTo
	outer['From'] = sender
	outer.preamble = 'You will not see this in a MIME-aware mail reader.\n'

	for filename in os.listdir(directory):
		path = os.path.join(directory, filename)
		if not os.path.isfile(path):
			continue
# Guess the content type based on the file's extension.  Encoding
# will be ignored, although we should check for simple things like
# gzip'd or compressed files.
		ctype, encoding = mimetypes.guess_type(path)
		if ctype is None or encoding is not None:
# No guess could be made, or the file is encoded (compressed), so
# use a generic bag-of-bits type.
			ctype = 'application/octet-stream'
		maintype, subtype = ctype.split('/', 1)
		if maintype == 'text':
			fp = open(path)
# Note: we should handle calculating the charset
			msg = MIMEText(fp.read(), _subtype=subtype)
			fp.close()
		elif maintype == 'image':
			fp = open(path, 'rb')
			msg = MIMEImage(fp.read(), _subtype=subtype)
			fp.close()
		elif maintype == 'audio':
			fp = open(path, 'rb')
			msg = MIMEAudio(fp.read(), _subtype=subtype)
			fp.close()
		else:
			fp = open(path, 'rb')
			msg = MIMEBase(maintype, subtype)
			msg.set_payload(fp.read())
			fp.close()
# Encode the payload using Base64
		encoders.encode_base64(msg)
# Set the filename parameter
		msg.add_header('Content-Disposition', 'attachment', filename=filename)
		outer.attach(msg)
# Now send or store the message
	composed = outer.as_string()
	if output:
		fp = open(output, 'w')
		fp.write(composed)
		fp.close()
	else:
		for x in range(10):
# try to connect to SMTP server & send email
			try:
				s = smtplib.SMTP('172.16.10.196')
				s.sendmail(sender, recipients, composed)
				s.quit()
				break
			except Exception as Err:
				pass


if __name__ == '__main__':
	main()